/* window.c generated by valac 0.56.3, the Vala compiler
 * generated from window.vala, do not modify */

/*
   This file is part of Swell-Foop.

   Copyright (C) 2020 Arnaud Bonatti <arnaud.bonatti@gmail.com>

   Swell-Foop is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   Swell-Foop is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Swell-Foop.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <clutter-gtk/clutter-gtk.h>
#include <glib.h>
#include <libgnome-games-support.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <errno.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SWELL_FOOP_WINDOW (swell_foop_window_get_type ())
#define SWELL_FOOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SWELL_FOOP_WINDOW, SwellFoopWindow))
#define SWELL_FOOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SWELL_FOOP_WINDOW, SwellFoopWindowClass))
#define IS_SWELL_FOOP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SWELL_FOOP_WINDOW))
#define IS_SWELL_FOOP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SWELL_FOOP_WINDOW))
#define SWELL_FOOP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SWELL_FOOP_WINDOW, SwellFoopWindowClass))

typedef struct _SwellFoopWindow SwellFoopWindow;
typedef struct _SwellFoopWindowClass SwellFoopWindowClass;
typedef struct _SwellFoopWindowPrivate SwellFoopWindowPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
enum  {
	SWELL_FOOP_WINDOW_0_PROPERTY,
	SWELL_FOOP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* swell_foop_window_properties[SWELL_FOOP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SWELL_FOOP_WINDOW_TYPE_SIZE (swell_foop_window_size_get_type ())
typedef struct _SwellFoopWindowSize SwellFoopWindowSize;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SwellFoopWindow {
	GtkApplicationWindow parent_instance;
	SwellFoopWindowPrivate * priv;
};

struct _SwellFoopWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _SwellFoopWindowPrivate {
	GtkHeaderBar* headerbar;
	GtkBox* main_box;
	GtkMenuButton* hamburger_button;
	GSettings* settings;
	Game* game;
	GameView* view;
	gboolean game_in_progress;
	GSimpleAction* undo_action;
	GSimpleAction* redo_action;
	GtkEventControllerKey* key_controller;
	GamesScoresContext* scores_context;
	GtkEventControllerMotion* motion_controller;
};

struct _SwellFoopWindowSize {
	gchar* id;
	gchar* name;
	guint8 columns;
	guint8 rows;
};

struct _Block2Data {
	int _ref_count_;
	SwellFoopWindow* self;
	GtkStack* stack;
};

static gint SwellFoopWindow_private_offset;
static gpointer swell_foop_window_parent_class = NULL;
static SwellFoopWindowSize* swell_foop_window_sizes;
static gint swell_foop_window_sizes_length1;
static SwellFoopWindowSize* swell_foop_window_sizes = NULL;
static gint swell_foop_window_sizes_length1 = 0;
static gint _swell_foop_window_sizes_size_ = 0;
static GHashTable* swell_foop_window_score_categories;
static GHashTable* swell_foop_window_score_categories = NULL;

VALA_EXTERN GType swell_foop_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SwellFoopWindow, g_object_unref)
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN GType game_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
static inline void swell_foop_window_change_theme_cb (SwellFoopWindow* self,
                                        GSimpleAction* action,
                                        GVariant* variant);
static void _swell_foop_window_change_theme_cb_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                              GVariant* value,
                                                                              gpointer self);
static inline void swell_foop_window_change_colors_cb (SwellFoopWindow* self,
                                         GSimpleAction* action,
                                         GVariant* variant);
static void _swell_foop_window_change_colors_cb_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                               GVariant* value,
                                                                               gpointer self);
static inline void swell_foop_window_new_game_cb (SwellFoopWindow* self);
static void _swell_foop_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
static inline void swell_foop_window_scores_cb (SwellFoopWindow* self);
static void _swell_foop_window_scores_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
static inline void swell_foop_window_toggle_hamburger (SwellFoopWindow* self);
static void _swell_foop_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static inline void swell_foop_window_undo (SwellFoopWindow* self);
static void _swell_foop_window_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static inline void swell_foop_window_redo (SwellFoopWindow* self);
static void _swell_foop_window_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static GType swell_foop_window_size_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SwellFoopWindowSize* swell_foop_window_size_dup (const SwellFoopWindowSize* self);
static void swell_foop_window_size_free (SwellFoopWindowSize* self);
static void swell_foop_window_size_copy (const SwellFoopWindowSize* self,
                                  SwellFoopWindowSize* dest);
static void swell_foop_window_size_destroy (SwellFoopWindowSize* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (SwellFoopWindowSize, swell_foop_window_size_destroy)
static inline void swell_foop_window_class_init_sizes (void);
static void _vala_SwellFoopWindowSize_array_free (SwellFoopWindowSize * array,
                                           gssize array_length);
VALA_EXTERN SwellFoopWindow* swell_foop_window_new (GtkApplication* application);
VALA_EXTERN SwellFoopWindow* swell_foop_window_construct (GType object_type,
                                              GtkApplication* application);
static void swell_foop_window_new_game (SwellFoopWindow* self,
                                 GVariant* saved_game);
static inline void swell_foop_window_init_motion (SwellFoopWindow* self);
static inline GtkStack* swell_foop_window_build_first_run_stack (SwellFoopWindow* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda9_ (Block2Data* _data2_);
static inline void swell_foop_window_init_keyboard (SwellFoopWindow* self);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void swell_foop_window_update_score_cb (SwellFoopWindow* self);
VALA_EXTERN guint game_get_score (Game* self);
static void swell_foop_window_complete_cb (SwellFoopWindow* self);
static gboolean __lambda7_ (SwellFoopWindow* self);
static inline void swell_foop_window_add_score (SwellFoopWindow* self);
static gboolean ___lambda7__gsource_func (gpointer self);
static inline void swell_foop_window_started_cb (SwellFoopWindow* self);
static void swell_foop_window_get_board_size (SwellFoopWindow* self,
                                       SwellFoopWindowSize* result);
VALA_EXTERN Game* game_new (guint8 rows,
                guint8 columns,
                guint8 color_num,
                GVariant* saved_game);
VALA_EXTERN Game* game_construct (GType object_type,
                      guint8 rows,
                      guint8 columns,
                      guint8 color_num,
                      GVariant* saved_game);
static void _swell_foop_window_update_score_cb_game_update_score (Game* _sender,
                                                           guint points_awarded,
                                                           gpointer self);
static void _swell_foop_window_complete_cb_game_complete (Game* _sender,
                                                   gpointer self);
static void _swell_foop_window_started_cb_game_started (Game* _sender,
                                                 gpointer self);
VALA_EXTERN void game_view_set_theme_name (GameView* self,
                               const gchar* theme_name);
VALA_EXTERN void game_view_set_is_zealous (GameView* self,
                               gboolean is_zealous);
VALA_EXTERN void game_view_set_game (GameView* self,
                         Game* game);
static void swell_foop_window_real_destroy (GtkWidget* base);
VALA_EXTERN GVariant* game_get_saved_game (Game* self);
VALA_EXTERN guint8 game_get_color_num (Game* self);
VALA_EXTERN guint8 game_get_rows (Game* self);
VALA_EXTERN guint8 game_get_columns (Game* self);
static inline void swell_foop_window_show_new_game_confirmation_dialog (SwellFoopWindow* self);
VALA_EXTERN void game_undo (Game* self);
VALA_EXTERN void game_redo (Game* self);
static inline gboolean swell_foop_window_on_key_pressed (SwellFoopWindow* self,
                                           GtkEventControllerKey* _key_controller,
                                           guint keyval,
                                           guint keycode,
                                           GdkModifierType state);
static gboolean _swell_foop_window_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                 guint keyval,
                                                                                 guint keycode,
                                                                                 GdkModifierType state,
                                                                                 gpointer self);
VALA_EXTERN void game_view_cursor_move (GameView* self,
                            gint x,
                            gint y);
VALA_EXTERN void game_view_cursor_click (GameView* self);
static inline void swell_foop_window_class_init_scores (void);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static inline void swell_foop_window_init_scores (SwellFoopWindow* self);
static inline GamesScoresCategory* swell_foop_window_category_request (SwellFoopWindow* self,
                                                         const gchar* key);
static GamesScoresCategory* _swell_foop_window_category_request_games_scores_context_category_request_func (const gchar* category_key,
                                                                                                     gpointer self);
static inline void swell_foop_window_parse_old_score (SwellFoopWindow* self,
                                        const gchar* line,
                                        GamesScoresScore** score,
                                        GamesScoresCategory** category);
static void _swell_foop_window_parse_old_score_games_scores_history_file_importer_history_convert_func (const gchar* line,
                                                                                                 GamesScoresScore** score,
                                                                                                 GamesScoresCategory** category,
                                                                                                 gpointer self);
static void __lambda8_ (SwellFoopWindow* self,
                 GObject* object,
                 GAsyncResult* _result_);
static void ___lambda8__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
VALA_EXTERN void game_view_board_left_cb (GameView* self);
static void _game_view_board_left_cb_gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                                 gpointer self);
static GObject * swell_foop_window_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _swell_foop_window___lambda10_ (SwellFoopWindow* self,
                                     GSettings* _settings,
                                     const gchar* _key_name);
static void __swell_foop_window___lambda10__g_settings_changed (GSettings* _sender,
                                                         const gchar* key,
                                                         gpointer self);
VALA_EXTERN GameView* game_view_new (void);
VALA_EXTERN GameView* game_view_construct (GType object_type);
static void swell_foop_window_finalize (GObject * obj);
static GType swell_foop_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry SWELL_FOOP_WINDOW_win_actions[7] = {{"change-theme", NULL, "s", "'shapesandcolors'", _swell_foop_window_change_theme_cb_gsimple_action_change_state_callback}, {"change-colors", NULL, "s", "'3'", _swell_foop_window_change_colors_cb_gsimple_action_change_state_callback}, {"new-game", _swell_foop_window_new_game_cb_gsimple_action_activate_callback}, {"scores", _swell_foop_window_scores_cb_gsimple_action_activate_callback}, {"toggle-hamburger", _swell_foop_window_toggle_hamburger_gsimple_action_activate_callback}, {"undo", _swell_foop_window_undo_gsimple_action_activate_callback}, {"redo", _swell_foop_window_redo_gsimple_action_activate_callback}};

static inline gpointer
swell_foop_window_get_instance_private (SwellFoopWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SwellFoopWindow_private_offset);
}

static void
_swell_foop_window_change_theme_cb_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                         GVariant* value,
                                                                         gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_change_theme_cb ((SwellFoopWindow*) self, action, value);
#line 319 "window.c"
}

static void
_swell_foop_window_change_colors_cb_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                          GVariant* value,
                                                                          gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_change_colors_cb ((SwellFoopWindow*) self, action, value);
#line 329 "window.c"
}

static void
_swell_foop_window_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_new_game_cb ((SwellFoopWindow*) self);
#line 339 "window.c"
}

static void
_swell_foop_window_scores_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_scores_cb ((SwellFoopWindow*) self);
#line 349 "window.c"
}

static void
_swell_foop_window_toggle_hamburger_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_toggle_hamburger ((SwellFoopWindow*) self);
#line 359 "window.c"
}

static void
_swell_foop_window_undo_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_undo ((SwellFoopWindow*) self);
#line 369 "window.c"
}

static void
_swell_foop_window_redo_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 68 "../src/window.vala"
	swell_foop_window_redo ((SwellFoopWindow*) self);
#line 379 "window.c"
}

static void
_vala_SwellFoopWindowSize_array_free (SwellFoopWindowSize * array,
                                      gssize array_length)
{
#line 50 "../src/window.vala"
	if (array != NULL) {
#line 388 "window.c"
		gssize i;
#line 50 "../src/window.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 50 "../src/window.vala"
			swell_foop_window_size_destroy (&array[i]);
#line 394 "window.c"
		}
	}
#line 50 "../src/window.vala"
	g_free (array);
#line 399 "window.c"
}

static inline void
swell_foop_window_class_init_sizes (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	SwellFoopWindowSize _tmp2_ = {0};
	gchar* _tmp3_;
	gchar* _tmp4_;
	SwellFoopWindowSize _tmp5_ = {0};
	gchar* _tmp6_;
	gchar* _tmp7_;
	SwellFoopWindowSize _tmp8_ = {0};
	SwellFoopWindowSize* _tmp9_;
#line 50 "../src/window.vala"
	_tmp0_ = g_strdup ("small");
#line 50 "../src/window.vala"
	_tmp1_ = g_strdup (_ ("Small"));
#line 50 "../src/window.vala"
	memset (&_tmp2_, 0, sizeof (SwellFoopWindowSize));
#line 50 "../src/window.vala"
	_g_free0 (_tmp2_.id);
#line 50 "../src/window.vala"
	_tmp2_.id = _tmp0_;
#line 50 "../src/window.vala"
	_g_free0 (_tmp2_.name);
#line 50 "../src/window.vala"
	_tmp2_.name = _tmp1_;
#line 50 "../src/window.vala"
	_tmp2_.columns = (guint8) 6;
#line 50 "../src/window.vala"
	_tmp2_.rows = (guint8) 5;
#line 50 "../src/window.vala"
	_tmp3_ = g_strdup ("normal");
#line 50 "../src/window.vala"
	_tmp4_ = g_strdup (_ ("Normal"));
#line 50 "../src/window.vala"
	memset (&_tmp5_, 0, sizeof (SwellFoopWindowSize));
#line 50 "../src/window.vala"
	_g_free0 (_tmp5_.id);
#line 50 "../src/window.vala"
	_tmp5_.id = _tmp3_;
#line 50 "../src/window.vala"
	_g_free0 (_tmp5_.name);
#line 50 "../src/window.vala"
	_tmp5_.name = _tmp4_;
#line 50 "../src/window.vala"
	_tmp5_.columns = (guint8) 15;
#line 50 "../src/window.vala"
	_tmp5_.rows = (guint8) 10;
#line 50 "../src/window.vala"
	_tmp6_ = g_strdup ("large");
#line 50 "../src/window.vala"
	_tmp7_ = g_strdup (_ ("Large"));
#line 50 "../src/window.vala"
	memset (&_tmp8_, 0, sizeof (SwellFoopWindowSize));
#line 50 "../src/window.vala"
	_g_free0 (_tmp8_.id);
#line 50 "../src/window.vala"
	_tmp8_.id = _tmp6_;
#line 50 "../src/window.vala"
	_g_free0 (_tmp8_.name);
#line 50 "../src/window.vala"
	_tmp8_.name = _tmp7_;
#line 50 "../src/window.vala"
	_tmp8_.columns = (guint8) 20;
#line 50 "../src/window.vala"
	_tmp8_.rows = (guint8) 15;
#line 50 "../src/window.vala"
	_tmp9_ = g_new0 (SwellFoopWindowSize, 3);
#line 50 "../src/window.vala"
	_tmp9_[0] = _tmp2_;
#line 50 "../src/window.vala"
	_tmp9_[1] = _tmp5_;
#line 50 "../src/window.vala"
	_tmp9_[2] = _tmp8_;
#line 50 "../src/window.vala"
	swell_foop_window_sizes = (_vala_SwellFoopWindowSize_array_free (swell_foop_window_sizes, swell_foop_window_sizes_length1), NULL);
#line 50 "../src/window.vala"
	swell_foop_window_sizes = _tmp9_;
#line 50 "../src/window.vala"
	swell_foop_window_sizes_length1 = 3;
#line 50 "../src/window.vala"
	_swell_foop_window_sizes_size_ = swell_foop_window_sizes_length1;
#line 485 "window.c"
}

SwellFoopWindow*
swell_foop_window_construct (GType object_type,
                             GtkApplication* application)
{
	SwellFoopWindow * self = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
#line 125 "../src/window.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 127 "../src/window.vala"
	self = (SwellFoopWindow*) g_object_new (object_type, "application", application, NULL);
#line 129 "../src/window.vala"
	_tmp0_ = self->priv->settings;
#line 129 "../src/window.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, "saved-game");
#line 129 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 129 "../src/window.vala"
	swell_foop_window_new_game (self, _tmp2_);
#line 129 "../src/window.vala"
	_g_variant_unref0 (_tmp2_);
#line 131 "../src/window.vala"
	swell_foop_window_init_motion (self);
#line 125 "../src/window.vala"
	return self;
#line 514 "window.c"
}

SwellFoopWindow*
swell_foop_window_new (GtkApplication* application)
{
#line 125 "../src/window.vala"
	return swell_foop_window_construct (TYPE_SWELL_FOOP_WINDOW, application);
#line 522 "window.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 134 "../src/window.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 134 "../src/window.vala"
	return _data2_;
#line 532 "window.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 134 "../src/window.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 542 "window.c"
		SwellFoopWindow* self;
#line 134 "../src/window.vala"
		self = _data2_->self;
#line 134 "../src/window.vala"
		_g_object_unref0 (_data2_->stack);
#line 134 "../src/window.vala"
		_g_object_unref0 (self);
#line 134 "../src/window.vala"
		g_slice_free (Block2Data, _data2_);
#line 552 "window.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 138 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 561 "window.c"
}

static void
__lambda9_ (Block2Data* _data2_)
{
	SwellFoopWindow* self;
	GSettings* _tmp0_;
#line 148 "../src/window.vala"
	self = _data2_->self;
#line 153 "../src/window.vala"
	gtk_stack_set_transition_type (_data2_->stack, GTK_STACK_TRANSITION_TYPE_SLIDE_UP);
#line 154 "../src/window.vala"
	gtk_stack_set_transition_duration (_data2_->stack, (guint) 500);
#line 156 "../src/window.vala"
	gtk_stack_set_visible_child_name (_data2_->stack, "game");
#line 157 "../src/window.vala"
	swell_foop_window_init_keyboard (self);
#line 158 "../src/window.vala"
	_tmp0_ = self->priv->settings;
#line 158 "../src/window.vala"
	g_settings_set_boolean (_tmp0_, "first-run", FALSE);
#line 583 "window.c"
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 148 "../src/window.vala"
	__lambda9_ (self);
#line 592 "window.c"
}

static inline GtkStack*
swell_foop_window_build_first_run_stack (SwellFoopWindow* self)
{
	Block2Data* _data2_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GdkScreen* gdk_screen = NULL;
	GdkScreen* _tmp2_;
	GdkScreen* _tmp3_;
	GdkScreen* _tmp4_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp7_;
	GObject* _tmp8_;
	GtkStack* _tmp9_;
	GtkLabel* tip_label = NULL;
	GObject* _tmp10_;
	GtkLabel* _tmp11_;
	GtkButton* play_button = NULL;
	GObject* _tmp12_;
	GtkButton* _tmp13_;
	GtkStack* _tmp14_;
	GtkStack* result;
#line 134 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../src/window.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 134 "../src/window.vala"
	_data2_->_ref_count_ = 1;
#line 134 "../src/window.vala"
	_data2_->self = g_object_ref (self);
#line 136 "../src/window.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 136 "../src/window.vala"
	css_provider = _tmp0_;
#line 137 "../src/window.vala"
	_tmp1_ = css_provider;
#line 137 "../src/window.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "/org/gnome/SwellFoop/ui/swell-foop.css");
#line 138 "../src/window.vala"
	_tmp2_ = gdk_screen_get_default ();
#line 138 "../src/window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 138 "../src/window.vala"
	gdk_screen = _tmp3_;
#line 139 "../src/window.vala"
	_tmp4_ = gdk_screen;
#line 139 "../src/window.vala"
	if (_tmp4_ != NULL) {
#line 644 "window.c"
		GdkScreen* _tmp5_;
		GtkCssProvider* _tmp6_;
#line 140 "../src/window.vala"
		_tmp5_ = gdk_screen;
#line 140 "../src/window.vala"
		_tmp6_ = css_provider;
#line 140 "../src/window.vala"
		gtk_style_context_add_provider_for_screen (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_screen_get_type (), GdkScreen), (GtkStyleProvider*) _tmp6_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 653 "window.c"
	}
#line 142 "../src/window.vala"
	_tmp7_ = gtk_builder_new_from_resource ("/org/gnome/SwellFoop/ui/first-run-stack.ui");
#line 142 "../src/window.vala"
	builder = _tmp7_;
#line 143 "../src/window.vala"
	_tmp8_ = gtk_builder_get_object (builder, "first_run_stack");
#line 143 "../src/window.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_stack_get_type (), GtkStack));
#line 143 "../src/window.vala"
	_data2_->stack = _tmp9_;
#line 144 "../src/window.vala"
	_tmp10_ = gtk_builder_get_object (builder, "tip_label");
#line 144 "../src/window.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_label_get_type (), GtkLabel));
#line 144 "../src/window.vala"
	tip_label = _tmp11_;
#line 146 "../src/window.vala"
	gtk_label_set_label (tip_label, _ ("Clear as many blocks as you can.\nFewer clicks means more points."));
#line 147 "../src/window.vala"
	_tmp12_ = gtk_builder_get_object (builder, "play_button");
#line 147 "../src/window.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_button_get_type (), GtkButton));
#line 147 "../src/window.vala"
	play_button = _tmp13_;
#line 148 "../src/window.vala"
	g_signal_connect_data (play_button, "clicked", (GCallback) ___lambda9__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 160 "../src/window.vala"
	_tmp14_ = _g_object_ref0 (_data2_->stack);
#line 160 "../src/window.vala"
	result = _tmp14_;
#line 160 "../src/window.vala"
	_g_object_unref0 (play_button);
#line 160 "../src/window.vala"
	_g_object_unref0 (tip_label);
#line 160 "../src/window.vala"
	_g_object_unref0 (builder);
#line 160 "../src/window.vala"
	_g_object_unref0 (gdk_screen);
#line 160 "../src/window.vala"
	_g_object_unref0 (css_provider);
#line 160 "../src/window.vala"
	block2_data_unref (_data2_);
#line 160 "../src/window.vala"
	_data2_ = NULL;
#line 160 "../src/window.vala"
	return result;
#line 701 "window.c"
}

static void
swell_foop_window_update_score_cb (SwellFoopWindow* self)
{
	guint score = 0U;
	Game* _tmp0_;
	GtkHeaderBar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 167 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/window.vala"
	score = (guint) 0;
#line 170 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 170 "../src/window.vala"
	if (_tmp0_ != NULL) {
#line 720 "window.c"
		Game* _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
#line 171 "../src/window.vala"
		_tmp1_ = self->priv->game;
#line 171 "../src/window.vala"
		_tmp2_ = game_get_score (_tmp1_);
#line 171 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 171 "../src/window.vala"
		score = _tmp3_;
#line 732 "window.c"
	}
#line 174 "../src/window.vala"
	_tmp4_ = self->priv->headerbar;
#line 174 "../src/window.vala"
	_tmp5_ = g_strdup_printf (_ ("Score: %u"), score);
#line 174 "../src/window.vala"
	_tmp6_ = _tmp5_;
#line 174 "../src/window.vala"
	gtk_header_bar_set_subtitle (_tmp4_, _tmp6_);
#line 174 "../src/window.vala"
	_g_free0 (_tmp6_);
#line 744 "window.c"
}

static gboolean
__lambda7_ (SwellFoopWindow* self)
{
	gboolean result;
#line 180 "../src/window.vala"
	swell_foop_window_add_score (self);
#line 180 "../src/window.vala"
	result = G_SOURCE_REMOVE;
#line 180 "../src/window.vala"
	return result;
#line 757 "window.c"
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ ((SwellFoopWindow*) self);
#line 180 "../src/window.vala"
	return result;
#line 767 "window.c"
}

static void
swell_foop_window_complete_cb (SwellFoopWindow* self)
{
	GSimpleAction* _tmp0_;
#line 177 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/window.vala"
	_tmp0_ = self->priv->undo_action;
#line 179 "../src/window.vala"
	g_simple_action_set_enabled (_tmp0_, FALSE);
#line 180 "../src/window.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, g_object_ref (self), g_object_unref);
#line 181 "../src/window.vala"
	self->priv->game_in_progress = FALSE;
#line 784 "window.c"
}

static inline void
swell_foop_window_started_cb (SwellFoopWindow* self)
{
#line 184 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/window.vala"
	self->priv->game_in_progress = TRUE;
#line 794 "window.c"
}

static void
swell_foop_window_get_board_size (SwellFoopWindow* self,
                                  SwellFoopWindowSize* result)
{
	gchar* current_size = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	SwellFoopWindowSize* _tmp13_;
	gint _tmp13__length1;
	SwellFoopWindowSize _tmp14_;
	SwellFoopWindowSize _tmp15_;
	SwellFoopWindowSize _tmp16_ = {0};
#line 189 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/window.vala"
	_tmp0_ = self->priv->settings;
#line 191 "../src/window.vala"
	_tmp1_ = g_settings_get_string (_tmp0_, "size");
#line 191 "../src/window.vala"
	current_size = _tmp1_;
#line 817 "window.c"
	{
		gint i = 0;
#line 192 "../src/window.vala"
		i = 0;
#line 822 "window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 192 "../src/window.vala"
			_tmp2_ = TRUE;
#line 192 "../src/window.vala"
			while (TRUE) {
#line 829 "window.c"
				SwellFoopWindowSize* _tmp4_;
				gint _tmp4__length1;
				SwellFoopWindowSize* _tmp5_;
				gint _tmp5__length1;
				SwellFoopWindowSize _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
#line 192 "../src/window.vala"
				if (!_tmp2_) {
#line 839 "window.c"
					gint _tmp3_;
#line 192 "../src/window.vala"
					_tmp3_ = i;
#line 192 "../src/window.vala"
					i = _tmp3_ + 1;
#line 845 "window.c"
				}
#line 192 "../src/window.vala"
				_tmp2_ = FALSE;
#line 192 "../src/window.vala"
				_tmp4_ = swell_foop_window_sizes;
#line 192 "../src/window.vala"
				_tmp4__length1 = swell_foop_window_sizes_length1;
#line 192 "../src/window.vala"
				if (!(i < _tmp4__length1)) {
#line 192 "../src/window.vala"
					break;
#line 857 "window.c"
				}
#line 194 "../src/window.vala"
				_tmp5_ = swell_foop_window_sizes;
#line 194 "../src/window.vala"
				_tmp5__length1 = swell_foop_window_sizes_length1;
#line 194 "../src/window.vala"
				_tmp6_ = _tmp5_[i];
#line 194 "../src/window.vala"
				_tmp7_ = _tmp6_.id;
#line 194 "../src/window.vala"
				_tmp8_ = current_size;
#line 194 "../src/window.vala"
				if (g_strcmp0 (_tmp7_, _tmp8_) == 0) {
#line 871 "window.c"
					SwellFoopWindowSize* _tmp9_;
					gint _tmp9__length1;
					SwellFoopWindowSize _tmp10_;
					SwellFoopWindowSize _tmp11_;
					SwellFoopWindowSize _tmp12_ = {0};
#line 195 "../src/window.vala"
					_tmp9_ = swell_foop_window_sizes;
#line 195 "../src/window.vala"
					_tmp9__length1 = swell_foop_window_sizes_length1;
#line 195 "../src/window.vala"
					_tmp10_ = _tmp9_[i];
#line 195 "../src/window.vala"
					_tmp11_ = _tmp10_;
#line 195 "../src/window.vala"
					swell_foop_window_size_copy (&_tmp11_, &_tmp12_);
#line 195 "../src/window.vala"
					*result = _tmp12_;
#line 195 "../src/window.vala"
					_g_free0 (current_size);
#line 195 "../src/window.vala"
					return;
#line 893 "window.c"
				}
			}
		}
	}
#line 198 "../src/window.vala"
	_tmp13_ = swell_foop_window_sizes;
#line 198 "../src/window.vala"
	_tmp13__length1 = swell_foop_window_sizes_length1;
#line 198 "../src/window.vala"
	_tmp14_ = _tmp13_[0];
#line 198 "../src/window.vala"
	_tmp15_ = _tmp14_;
#line 198 "../src/window.vala"
	swell_foop_window_size_copy (&_tmp15_, &_tmp16_);
#line 198 "../src/window.vala"
	*result = _tmp16_;
#line 198 "../src/window.vala"
	_g_free0 (current_size);
#line 198 "../src/window.vala"
	return;
#line 914 "window.c"
}

static void
_swell_foop_window_update_score_cb_game_update_score (Game* _sender,
                                                      guint points_awarded,
                                                      gpointer self)
{
#line 220 "../src/window.vala"
	swell_foop_window_update_score_cb ((SwellFoopWindow*) self);
#line 924 "window.c"
}

static void
_swell_foop_window_complete_cb_game_complete (Game* _sender,
                                              gpointer self)
{
#line 221 "../src/window.vala"
	swell_foop_window_complete_cb ((SwellFoopWindow*) self);
#line 933 "window.c"
}

static void
_swell_foop_window_started_cb_game_started (Game* _sender,
                                            gpointer self)
{
#line 222 "../src/window.vala"
	swell_foop_window_started_cb ((SwellFoopWindow*) self);
#line 942 "window.c"
}

static void
swell_foop_window_new_game (SwellFoopWindow* self,
                            GVariant* saved_game)
{
	SwellFoopWindowSize size = {0};
	SwellFoopWindowSize _tmp0_ = {0};
	SwellFoopWindowSize _tmp1_;
	SwellFoopWindowSize _tmp2_;
	GSettings* _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	Game* _tmp8_;
	Game* _tmp9_;
	Game* _tmp10_;
	GameView* _tmp11_;
	GSettings* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GameView* _tmp15_;
	GSettings* _tmp16_;
	GameView* _tmp17_;
	Game* _tmp18_;
	GAction* _tmp19_;
	GSimpleAction* _tmp20_;
	Game* _tmp21_;
	GSimpleAction* _tmp22_;
	GAction* _tmp23_;
	GSimpleAction* _tmp24_;
	Game* _tmp25_;
	GSimpleAction* _tmp26_;
#line 209 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/window.vala"
	swell_foop_window_get_board_size (self, &_tmp0_);
#line 211 "../src/window.vala"
	size = _tmp0_;
#line 212 "../src/window.vala"
	_tmp1_ = size;
#line 212 "../src/window.vala"
	_tmp2_ = size;
#line 212 "../src/window.vala"
	_tmp3_ = self->priv->settings;
#line 212 "../src/window.vala"
	_tmp4_ = game_new (_tmp1_.rows, _tmp2_.columns, (guint8) g_settings_get_int (_tmp3_, "colors"), saved_game);
#line 212 "../src/window.vala"
	_g_object_unref0 (self->priv->game);
#line 212 "../src/window.vala"
	self->priv->game = _tmp4_;
#line 216 "../src/window.vala"
	_tmp5_ = self->priv->game;
#line 216 "../src/window.vala"
	_tmp6_ = game_get_score (_tmp5_);
#line 216 "../src/window.vala"
	_tmp7_ = _tmp6_;
#line 216 "../src/window.vala"
	self->priv->game_in_progress = _tmp7_ != ((guint) 0);
#line 217 "../src/window.vala"
	swell_foop_window_update_score_cb (self);
#line 220 "../src/window.vala"
	_tmp8_ = self->priv->game;
#line 220 "../src/window.vala"
	g_signal_connect_object (_tmp8_, "update-score", (GCallback) _swell_foop_window_update_score_cb_game_update_score, self, 0);
#line 221 "../src/window.vala"
	_tmp9_ = self->priv->game;
#line 221 "../src/window.vala"
	g_signal_connect_object (_tmp9_, "complete", (GCallback) _swell_foop_window_complete_cb_game_complete, self, 0);
#line 222 "../src/window.vala"
	_tmp10_ = self->priv->game;
#line 222 "../src/window.vala"
	g_signal_connect_object (_tmp10_, "started", (GCallback) _swell_foop_window_started_cb_game_started, self, 0);
#line 225 "../src/window.vala"
	_tmp11_ = self->priv->view;
#line 225 "../src/window.vala"
	_tmp12_ = self->priv->settings;
#line 225 "../src/window.vala"
	_tmp13_ = g_settings_get_string (_tmp12_, "theme");
#line 225 "../src/window.vala"
	_tmp14_ = _tmp13_;
#line 225 "../src/window.vala"
	game_view_set_theme_name (_tmp11_, _tmp14_);
#line 225 "../src/window.vala"
	_g_free0 (_tmp14_);
#line 226 "../src/window.vala"
	_tmp15_ = self->priv->view;
#line 226 "../src/window.vala"
	_tmp16_ = self->priv->settings;
#line 226 "../src/window.vala"
	game_view_set_is_zealous (_tmp15_, g_settings_get_boolean (_tmp16_, "zealous"));
#line 227 "../src/window.vala"
	_tmp17_ = self->priv->view;
#line 227 "../src/window.vala"
	_tmp18_ = self->priv->game;
#line 227 "../src/window.vala"
	game_view_set_game (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_GAME, Game));
#line 230 "../src/window.vala"
	_tmp19_ = g_action_map_lookup_action ((GActionMap*) self, "undo");
#line 230 "../src/window.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, g_simple_action_get_type (), GSimpleAction));
#line 230 "../src/window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 230 "../src/window.vala"
	self->priv->undo_action = _tmp20_;
#line 231 "../src/window.vala"
	_tmp21_ = self->priv->game;
#line 231 "../src/window.vala"
	_tmp22_ = self->priv->undo_action;
#line 231 "../src/window.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp21_, "can-undo", (GObject*) _tmp22_, "enabled", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 233 "../src/window.vala"
	_tmp23_ = g_action_map_lookup_action ((GActionMap*) self, "redo");
#line 233 "../src/window.vala"
	_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, g_simple_action_get_type (), GSimpleAction));
#line 233 "../src/window.vala"
	_g_object_unref0 (self->priv->redo_action);
#line 233 "../src/window.vala"
	self->priv->redo_action = _tmp24_;
#line 234 "../src/window.vala"
	_tmp25_ = self->priv->game;
#line 234 "../src/window.vala"
	_tmp26_ = self->priv->redo_action;
#line 234 "../src/window.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp25_, "can-redo", (GObject*) _tmp26_, "enabled", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 209 "../src/window.vala"
	swell_foop_window_size_destroy (&size);
#line 1071 "window.c"
}

static void
swell_foop_window_real_destroy (GtkWidget* base)
{
	SwellFoopWindow * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	Game* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GSettings* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	GSettings* _tmp27_;
#line 237 "../src/window.vala"
	self = (SwellFoopWindow*) base;
#line 239 "../src/window.vala"
	_tmp0_ = self->priv->settings;
#line 239 "../src/window.vala"
	g_settings_delay (_tmp0_);
#line 240 "../src/window.vala"
	_tmp1_ = self->priv->settings;
#line 240 "../src/window.vala"
	_tmp2_ = self->priv->game;
#line 240 "../src/window.vala"
	_tmp3_ = game_get_saved_game (_tmp2_);
#line 240 "../src/window.vala"
	_tmp4_ = _tmp3_;
#line 240 "../src/window.vala"
	g_settings_set_value (_tmp1_, "saved-game", _tmp4_);
#line 240 "../src/window.vala"
	_g_variant_unref0 (_tmp4_);
#line 241 "../src/window.vala"
	_tmp5_ = self->priv->settings;
#line 241 "../src/window.vala"
	_tmp6_ = self->priv->game;
#line 241 "../src/window.vala"
	_tmp7_ = game_get_color_num (_tmp6_);
#line 241 "../src/window.vala"
	_tmp8_ = _tmp7_;
#line 241 "../src/window.vala"
	g_settings_set_int (_tmp5_, "colors", (gint) _tmp8_);
#line 1116 "window.c"
	{
		guint8 i = 0U;
#line 242 "../src/window.vala"
		i = (guint8) 0;
#line 1121 "window.c"
		{
			gboolean _tmp9_ = FALSE;
#line 242 "../src/window.vala"
			_tmp9_ = TRUE;
#line 242 "../src/window.vala"
			while (TRUE) {
#line 1128 "window.c"
				SwellFoopWindowSize* _tmp11_;
				gint _tmp11__length1;
				gboolean _tmp12_ = FALSE;
				Game* _tmp13_;
				guint8 _tmp14_;
				guint8 _tmp15_;
				SwellFoopWindowSize* _tmp16_;
				gint _tmp16__length1;
				SwellFoopWindowSize _tmp17_;
#line 242 "../src/window.vala"
				if (!_tmp9_) {
#line 1140 "window.c"
					guint8 _tmp10_;
#line 242 "../src/window.vala"
					_tmp10_ = i;
#line 242 "../src/window.vala"
					i = _tmp10_ + 1;
#line 1146 "window.c"
				}
#line 242 "../src/window.vala"
				_tmp9_ = FALSE;
#line 242 "../src/window.vala"
				_tmp11_ = swell_foop_window_sizes;
#line 242 "../src/window.vala"
				_tmp11__length1 = swell_foop_window_sizes_length1;
#line 242 "../src/window.vala"
				if (!(((gint) i) < _tmp11__length1)) {
#line 242 "../src/window.vala"
					break;
#line 1158 "window.c"
				}
#line 243 "../src/window.vala"
				_tmp13_ = self->priv->game;
#line 243 "../src/window.vala"
				_tmp14_ = game_get_rows (_tmp13_);
#line 243 "../src/window.vala"
				_tmp15_ = _tmp14_;
#line 243 "../src/window.vala"
				_tmp16_ = swell_foop_window_sizes;
#line 243 "../src/window.vala"
				_tmp16__length1 = swell_foop_window_sizes_length1;
#line 243 "../src/window.vala"
				_tmp17_ = _tmp16_[i];
#line 243 "../src/window.vala"
				if (_tmp15_ == _tmp17_.rows) {
#line 1174 "window.c"
					Game* _tmp18_;
					guint8 _tmp19_;
					guint8 _tmp20_;
					SwellFoopWindowSize* _tmp21_;
					gint _tmp21__length1;
					SwellFoopWindowSize _tmp22_;
#line 243 "../src/window.vala"
					_tmp18_ = self->priv->game;
#line 243 "../src/window.vala"
					_tmp19_ = game_get_columns (_tmp18_);
#line 243 "../src/window.vala"
					_tmp20_ = _tmp19_;
#line 243 "../src/window.vala"
					_tmp21_ = swell_foop_window_sizes;
#line 243 "../src/window.vala"
					_tmp21__length1 = swell_foop_window_sizes_length1;
#line 243 "../src/window.vala"
					_tmp22_ = _tmp21_[i];
#line 243 "../src/window.vala"
					_tmp12_ = _tmp20_ == _tmp22_.columns;
#line 1195 "window.c"
				} else {
#line 243 "../src/window.vala"
					_tmp12_ = FALSE;
#line 1199 "window.c"
				}
#line 243 "../src/window.vala"
				if (_tmp12_) {
#line 1203 "window.c"
					GSettings* _tmp23_;
					SwellFoopWindowSize* _tmp24_;
					gint _tmp24__length1;
					SwellFoopWindowSize _tmp25_;
					const gchar* _tmp26_;
#line 245 "../src/window.vala"
					_tmp23_ = self->priv->settings;
#line 245 "../src/window.vala"
					_tmp24_ = swell_foop_window_sizes;
#line 245 "../src/window.vala"
					_tmp24__length1 = swell_foop_window_sizes_length1;
#line 245 "../src/window.vala"
					_tmp25_ = _tmp24_[i];
#line 245 "../src/window.vala"
					_tmp26_ = _tmp25_.id;
#line 245 "../src/window.vala"
					g_settings_set_string (_tmp23_, "size", _tmp26_);
#line 246 "../src/window.vala"
					break;
#line 1223 "window.c"
				}
			}
		}
	}
#line 248 "../src/window.vala"
	_tmp27_ = self->priv->settings;
#line 248 "../src/window.vala"
	g_settings_apply (_tmp27_);
#line 250 "../src/window.vala"
	GTK_WIDGET_CLASS (swell_foop_window_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow));
#line 1234 "window.c"
}

static inline void
swell_foop_window_change_theme_cb (SwellFoopWindow* self,
                                   GSimpleAction* action,
                                   GVariant* variant)
{
	gchar* new_theme = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GameView* _tmp2_;
	const gchar* _tmp3_;
	GSettings* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_;
#line 257 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/window.vala"
	g_return_if_fail (action != NULL);
#line 257 "../src/window.vala"
	_vala_return_if_fail (variant != NULL, "variant != null");
#line 260 "../src/window.vala"
	_tmp0_ = g_variant_get_string ((GVariant*) variant, NULL);
#line 260 "../src/window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 260 "../src/window.vala"
	new_theme = _tmp1_;
#line 261 "../src/window.vala"
	g_simple_action_set_state (action, (GVariant*) variant);
#line 262 "../src/window.vala"
	_tmp2_ = self->priv->view;
#line 262 "../src/window.vala"
	_tmp3_ = new_theme;
#line 262 "../src/window.vala"
	game_view_set_theme_name (_tmp2_, _tmp3_);
#line 263 "../src/window.vala"
	_tmp4_ = self->priv->settings;
#line 263 "../src/window.vala"
	_tmp5_ = g_settings_get_string (_tmp4_, "theme");
#line 263 "../src/window.vala"
	_tmp6_ = _tmp5_;
#line 263 "../src/window.vala"
	_tmp7_ = new_theme;
#line 263 "../src/window.vala"
	_tmp8_ = g_strcmp0 (_tmp6_, _tmp7_) != 0;
#line 263 "../src/window.vala"
	_g_free0 (_tmp6_);
#line 263 "../src/window.vala"
	if (_tmp8_) {
#line 1286 "window.c"
		GSettings* _tmp9_;
		const gchar* _tmp10_;
#line 264 "../src/window.vala"
		_tmp9_ = self->priv->settings;
#line 264 "../src/window.vala"
		_tmp10_ = new_theme;
#line 264 "../src/window.vala"
		g_settings_set_string (_tmp9_, "theme", _tmp10_);
#line 1295 "window.c"
	}
#line 257 "../src/window.vala"
	_g_free0 (new_theme);
#line 1299 "window.c"
}

static inline void
swell_foop_window_change_colors_cb (SwellFoopWindow* self,
                                    GSimpleAction* action,
                                    GVariant* variant)
{
	gint32 new_colors = 0;
	const gchar* _tmp0_;
	GSettings* _tmp1_;
#line 267 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/window.vala"
	g_return_if_fail (action != NULL);
#line 267 "../src/window.vala"
	_vala_return_if_fail (variant != NULL, "variant != null");
#line 270 "../src/window.vala"
	_tmp0_ = g_variant_get_string ((GVariant*) variant, NULL);
#line 270 "../src/window.vala"
	new_colors = (gint32) atoi (_tmp0_);
#line 271 "../src/window.vala"
	g_simple_action_set_state (action, (GVariant*) variant);
#line 272 "../src/window.vala"
	_tmp1_ = self->priv->settings;
#line 272 "../src/window.vala"
	if (g_settings_get_int (_tmp1_, "colors") != ((gint) new_colors)) {
#line 1326 "window.c"
		GSettings* _tmp2_;
#line 273 "../src/window.vala"
		_tmp2_ = self->priv->settings;
#line 273 "../src/window.vala"
		g_settings_set_int (_tmp2_, "colors", (gint) new_colors);
#line 1332 "window.c"
	}
}

static inline void
swell_foop_window_scores_cb (SwellFoopWindow* self)
{
	GamesScoresContext* _tmp0_;
#line 276 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/window.vala"
	_tmp0_ = self->priv->scores_context;
#line 278 "../src/window.vala"
	games_scores_context_run_dialog (_tmp0_);
#line 1346 "window.c"
}

static inline void
swell_foop_window_new_game_cb (SwellFoopWindow* self)
{
#line 281 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/window.vala"
	if (self->priv->game_in_progress) {
#line 284 "../src/window.vala"
		swell_foop_window_show_new_game_confirmation_dialog (self);
#line 1358 "window.c"
	} else {
#line 286 "../src/window.vala"
		swell_foop_window_new_game (self, NULL);
#line 1362 "window.c"
	}
}

static inline void
swell_foop_window_show_new_game_confirmation_dialog (SwellFoopWindow* self)
{
	GtkMessageDialog* dialog = NULL;
	GtkMessageDialog* _tmp0_;
	GtkMessageDialog* _tmp1_;
	GtkMessageDialog* _tmp2_;
	gint _result_ = 0;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
#line 289 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 291 "../src/window.vala"
	_tmp0_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup ((GtkWindow*) self, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "<span weight=\"bold\" size=\"larger\">%s</span>", _ ("Abandon this game to start a new one?"));
#line 291 "../src/window.vala"
	g_object_ref_sink (_tmp0_);
#line 291 "../src/window.vala"
	dialog = _tmp0_;
#line 300 "../src/window.vala"
	_tmp1_ = dialog;
#line 300 "../src/window.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp1_, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 303 "../src/window.vala"
	_tmp2_ = dialog;
#line 303 "../src/window.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp2_, _ ("_New Game"), (gint) GTK_RESPONSE_YES);
#line 305 "../src/window.vala"
	_tmp3_ = dialog;
#line 305 "../src/window.vala"
	_result_ = gtk_dialog_run ((GtkDialog*) _tmp3_);
#line 306 "../src/window.vala"
	_tmp4_ = dialog;
#line 306 "../src/window.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp4_);
#line 308 "../src/window.vala"
	if (_result_ == ((gint) GTK_RESPONSE_YES)) {
#line 309 "../src/window.vala"
		swell_foop_window_new_game (self, NULL);
#line 1404 "window.c"
	}
#line 289 "../src/window.vala"
	_g_object_unref0 (dialog);
#line 1408 "window.c"
}

static inline void
swell_foop_window_toggle_hamburger (SwellFoopWindow* self)
{
	GtkMenuButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 312 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/window.vala"
	_tmp0_ = self->priv->hamburger_button;
#line 314 "../src/window.vala"
	_tmp1_ = self->priv->hamburger_button;
#line 314 "../src/window.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 314 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 314 "../src/window.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, !_tmp3_);
#line 1430 "window.c"
}

static inline void
swell_foop_window_undo (SwellFoopWindow* self)
{
	Game* _tmp0_;
#line 317 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 319 "../src/window.vala"
	game_undo (_tmp0_);
#line 1443 "window.c"
}

static inline void
swell_foop_window_redo (SwellFoopWindow* self)
{
	Game* _tmp0_;
#line 322 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 324 "../src/window.vala"
	game_redo (_tmp0_);
#line 1456 "window.c"
}

static gboolean
_swell_foop_window_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                        guint keyval,
                                                                        guint keycode,
                                                                        GdkModifierType state,
                                                                        gpointer self)
{
	gboolean result;
	result = swell_foop_window_on_key_pressed ((SwellFoopWindow*) self, _sender, keyval, keycode, state);
#line 336 "../src/window.vala"
	return result;
#line 1470 "window.c"
}

static inline void
swell_foop_window_init_keyboard (SwellFoopWindow* self)
{
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
#line 333 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 335 "../src/window.vala"
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 335 "../src/window.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 335 "../src/window.vala"
	self->priv->key_controller = _tmp0_;
#line 336 "../src/window.vala"
	_tmp1_ = self->priv->key_controller;
#line 336 "../src/window.vala"
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _swell_foop_window_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
#line 1490 "window.c"
}

static inline gboolean
swell_foop_window_on_key_pressed (SwellFoopWindow* self,
                                  GtkEventControllerKey* _key_controller,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state)
{
	GtkMenuButton* _tmp0_;
	gboolean result;
#line 339 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 339 "../src/window.vala"
	g_return_val_if_fail (_key_controller != NULL, FALSE);
#line 341 "../src/window.vala"
	_tmp0_ = self->priv->hamburger_button;
#line 341 "../src/window.vala"
	if (gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_)) {
#line 342 "../src/window.vala"
		result = FALSE;
#line 342 "../src/window.vala"
		return result;
#line 1514 "window.c"
	}
#line 344 "../src/window.vala"
	switch (keyval) {
#line 344 "../src/window.vala"
		case GDK_KEY_F2:
#line 1520 "window.c"
		{
#line 347 "../src/window.vala"
			swell_foop_window_new_game (self, NULL);
#line 348 "../src/window.vala"
			break;
#line 1526 "window.c"
		}
#line 344 "../src/window.vala"
		case GDK_KEY_Up:
#line 1530 "window.c"
		{
			GameView* _tmp1_;
#line 351 "../src/window.vala"
			_tmp1_ = self->priv->view;
#line 351 "../src/window.vala"
			game_view_cursor_move (_tmp1_, 0, 1);
#line 352 "../src/window.vala"
			break;
#line 1539 "window.c"
		}
#line 344 "../src/window.vala"
		case GDK_KEY_Down:
#line 1543 "window.c"
		{
			GameView* _tmp2_;
#line 354 "../src/window.vala"
			_tmp2_ = self->priv->view;
#line 354 "../src/window.vala"
			game_view_cursor_move (_tmp2_, 0, -1);
#line 355 "../src/window.vala"
			break;
#line 1552 "window.c"
		}
#line 344 "../src/window.vala"
		case GDK_KEY_Left:
#line 1556 "window.c"
		{
			GameView* _tmp3_;
#line 357 "../src/window.vala"
			_tmp3_ = self->priv->view;
#line 357 "../src/window.vala"
			game_view_cursor_move (_tmp3_, -1, 0);
#line 358 "../src/window.vala"
			break;
#line 1565 "window.c"
		}
#line 344 "../src/window.vala"
		case GDK_KEY_Right:
#line 1569 "window.c"
		{
			GameView* _tmp4_;
#line 360 "../src/window.vala"
			_tmp4_ = self->priv->view;
#line 360 "../src/window.vala"
			game_view_cursor_move (_tmp4_, 1, 0);
#line 361 "../src/window.vala"
			break;
#line 1578 "window.c"
		}
#line 344 "../src/window.vala"
		case GDK_KEY_space:
#line 344 "../src/window.vala"
		case GDK_KEY_Return:
#line 1584 "window.c"
		{
			GameView* _tmp5_;
#line 365 "../src/window.vala"
			_tmp5_ = self->priv->view;
#line 365 "../src/window.vala"
			game_view_cursor_click (_tmp5_);
#line 366 "../src/window.vala"
			result = TRUE;
#line 366 "../src/window.vala"
			return result;
#line 1595 "window.c"
		}
		default:
		{
#line 369 "../src/window.vala"
			break;
#line 1601 "window.c"
		}
	}
#line 372 "../src/window.vala"
	result = FALSE;
#line 372 "../src/window.vala"
	return result;
#line 1608 "window.c"
}

static void
_g_free0_ (gpointer var)
{
#line 384 "../src/window.vala"
	var = (g_free (var), NULL);
#line 1616 "window.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 384 "../src/window.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1624 "window.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1578 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1579 "glib-2.0.vapi"
	result = self;
#line 1579 "glib-2.0.vapi"
	return result;
#line 1637 "window.c"
}

static inline void
swell_foop_window_class_init_scores (void)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 384 "../src/window.vala"
	_tmp0_ = g_str_hash;
#line 384 "../src/window.vala"
	_tmp1_ = g_str_equal;
#line 384 "../src/window.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 384 "../src/window.vala"
	_g_hash_table_unref0 (swell_foop_window_score_categories);
#line 384 "../src/window.vala"
	swell_foop_window_score_categories = _tmp2_;
#line 1656 "window.c"
	{
		guint8 i = 0U;
#line 385 "../src/window.vala"
		i = (guint8) 2;
#line 1661 "window.c"
		{
			gboolean _tmp3_ = FALSE;
#line 385 "../src/window.vala"
			_tmp3_ = TRUE;
#line 385 "../src/window.vala"
			while (TRUE) {
#line 1668 "window.c"
				SwellFoopWindowSize* _tmp5_;
				gint _tmp5__length1;
#line 385 "../src/window.vala"
				if (!_tmp3_) {
#line 1673 "window.c"
					guint8 _tmp4_;
#line 385 "../src/window.vala"
					_tmp4_ = i;
#line 385 "../src/window.vala"
					i = _tmp4_ + 1;
#line 1679 "window.c"
				}
#line 385 "../src/window.vala"
				_tmp3_ = FALSE;
#line 385 "../src/window.vala"
				if (!(((gint) i) <= 4)) {
#line 385 "../src/window.vala"
					break;
#line 1687 "window.c"
				}
#line 386 "../src/window.vala"
				_tmp5_ = swell_foop_window_sizes;
#line 386 "../src/window.vala"
				_tmp5__length1 = swell_foop_window_sizes_length1;
#line 1693 "window.c"
				{
					SwellFoopWindowSize* size_collection = NULL;
					gint size_collection_length1 = 0;
					gint _size_collection_size_ = 0;
					gint size_it = 0;
#line 386 "../src/window.vala"
					size_collection = _tmp5_;
#line 386 "../src/window.vala"
					size_collection_length1 = _tmp5__length1;
#line 386 "../src/window.vala"
					for (size_it = 0; size_it < size_collection_length1; size_it = size_it + 1) {
#line 1705 "window.c"
						SwellFoopWindowSize size = {0};
#line 386 "../src/window.vala"
						size = size_collection[size_it];
#line 1709 "window.c"
						{
							gchar* id = NULL;
							SwellFoopWindowSize _tmp6_;
							const gchar* _tmp7_;
							const gchar* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
							gchar* name = NULL;
							SwellFoopWindowSize _tmp13_;
							const gchar* _tmp14_;
							gchar* _tmp15_;
							GamesScoresCategory* category = NULL;
							const gchar* _tmp16_;
							const gchar* _tmp17_;
							GamesScoresCategory* _tmp18_;
							GHashTable* _tmp19_;
							const gchar* _tmp20_;
							gchar* _tmp21_;
							GamesScoresCategory* _tmp22_;
#line 388 "../src/window.vala"
							_tmp6_ = size;
#line 388 "../src/window.vala"
							_tmp7_ = _tmp6_.id;
#line 388 "../src/window.vala"
							_tmp8_ = string_to_string (_tmp7_);
#line 388 "../src/window.vala"
							_tmp9_ = g_strdup_printf ("%hhu", i);
#line 388 "../src/window.vala"
							_tmp10_ = _tmp9_;
#line 388 "../src/window.vala"
							_tmp11_ = g_strconcat (_tmp8_, "-", _tmp10_, NULL);
#line 388 "../src/window.vala"
							_tmp12_ = _tmp11_;
#line 388 "../src/window.vala"
							_g_free0 (_tmp10_);
#line 388 "../src/window.vala"
							id = _tmp12_;
#line 389 "../src/window.vala"
							_tmp13_ = size;
#line 389 "../src/window.vala"
							_tmp14_ = _tmp13_.name;
#line 389 "../src/window.vala"
							_tmp15_ = g_strdup_printf (ngettext ("%s, %d color", "%s, %d colors", (gulong) i), _tmp14_, (gint) i);
#line 389 "../src/window.vala"
							name = _tmp15_;
#line 390 "../src/window.vala"
							_tmp16_ = id;
#line 390 "../src/window.vala"
							_tmp17_ = name;
#line 390 "../src/window.vala"
							_tmp18_ = games_scores_category_new (_tmp16_, _tmp17_);
#line 390 "../src/window.vala"
							category = _tmp18_;
#line 391 "../src/window.vala"
							_tmp19_ = swell_foop_window_score_categories;
#line 391 "../src/window.vala"
							_tmp20_ = id;
#line 391 "../src/window.vala"
							_tmp21_ = g_strdup (_tmp20_);
#line 391 "../src/window.vala"
							_tmp22_ = category;
#line 391 "../src/window.vala"
							category = NULL;
#line 391 "../src/window.vala"
							g_hash_table_insert (_tmp19_, _tmp21_, _tmp22_);
#line 386 "../src/window.vala"
							_g_object_unref0 (category);
#line 386 "../src/window.vala"
							_g_free0 (name);
#line 386 "../src/window.vala"
							_g_free0 (id);
#line 1783 "window.c"
						}
					}
				}
			}
		}
	}
}

static GamesScoresCategory*
_swell_foop_window_category_request_games_scores_context_category_request_func (const gchar* category_key,
                                                                                gpointer self)
{
	GamesScoresCategory* result;
	result = swell_foop_window_category_request ((SwellFoopWindow*) self, category_key);
#line 397 "../src/window.vala"
	return result;
#line 1800 "window.c"
}

static void
_swell_foop_window_parse_old_score_games_scores_history_file_importer_history_convert_func (const gchar* line,
                                                                                            GamesScoresScore** score,
                                                                                            GamesScoresCategory** category,
                                                                                            gpointer self)
{
#line 397 "../src/window.vala"
	swell_foop_window_parse_old_score ((SwellFoopWindow*) self, line, score, category);
#line 1811 "window.c"
}

static inline void
swell_foop_window_init_scores (SwellFoopWindow* self)
{
	GamesScoresHistoryFileImporter* _tmp0_;
	GamesScoresHistoryFileImporter* _tmp1_;
	GamesScoresContext* _tmp2_;
#line 395 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/window.vala"
	_tmp0_ = games_scores_history_file_importer_new (_swell_foop_window_parse_old_score_games_scores_history_file_importer_history_convert_func, self);
#line 397 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 397 "../src/window.vala"
	_tmp2_ = games_scores_context_new_with_importer_and_icon_name ("swell-foop", _ ("Type"), (GtkWindow*) self, _swell_foop_window_category_request_games_scores_context_category_request_func, self, GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER, (GamesScoresImporter*) _tmp1_, "org.gnome.SwellFoop");
#line 397 "../src/window.vala"
	_g_object_unref0 (self->priv->scores_context);
#line 397 "../src/window.vala"
	self->priv->scores_context = _tmp2_;
#line 397 "../src/window.vala"
	_g_object_unref0 (_tmp1_);
#line 1834 "window.c"
}

static inline GamesScoresCategory*
swell_foop_window_category_request (SwellFoopWindow* self,
                                    const gchar* key)
{
	GamesScoresCategory* category = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GamesScoresCategory* _tmp2_;
	GamesScoresCategory* _tmp3_;
	GamesScoresCategory* result;
#line 408 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 408 "../src/window.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 410 "../src/window.vala"
	_tmp0_ = swell_foop_window_score_categories;
#line 410 "../src/window.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, key);
#line 410 "../src/window.vala"
	_tmp2_ = _g_object_ref0 ((GamesScoresCategory*) _tmp1_);
#line 410 "../src/window.vala"
	category = _tmp2_;
#line 411 "../src/window.vala"
	if (category == NULL) {
#line 412 "../src/window.vala"
		g_assert_not_reached ();
#line 1863 "window.c"
	}
#line 413 "../src/window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (category, GAMES_SCORES_TYPE_CATEGORY, GamesScoresCategory));
#line 413 "../src/window.vala"
	result = _tmp3_;
#line 413 "../src/window.vala"
	_g_object_unref0 (category);
#line 413 "../src/window.vala"
	return result;
#line 1873 "window.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 843 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 845 "glib-2.0.vapi"
	errno = 0;
#line 846 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 846 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 846 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 847 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 847 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 847 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 847 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1909 "window.c"
		gboolean _tmp5_ = FALSE;
#line 848 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 849 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 849 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 1917 "window.c"
		} else {
#line 849 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 1921 "window.c"
		}
#line 849 "glib-2.0.vapi"
		result = _tmp5_;
#line 849 "glib-2.0.vapi"
		if (_result_) {
#line 849 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1929 "window.c"
		}
#line 849 "glib-2.0.vapi"
		if (unparsed) {
#line 849 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1935 "window.c"
		}
#line 849 "glib-2.0.vapi"
		return result;
#line 1939 "window.c"
	} else {
		gchar* _tmp6_;
#line 851 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 851 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 852 "glib-2.0.vapi"
		result = FALSE;
#line 852 "glib-2.0.vapi"
		if (_result_) {
#line 852 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1952 "window.c"
		}
#line 852 "glib-2.0.vapi"
		if (unparsed) {
#line 852 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1958 "window.c"
		}
#line 852 "glib-2.0.vapi"
		return result;
#line 1962 "window.c"
	}
}

static inline void
swell_foop_window_parse_old_score (SwellFoopWindow* self,
                                   const gchar* line,
                                   GamesScoresScore** score,
                                   GamesScoresCategory** category)
{
	GamesScoresScore* _vala_score = NULL;
	GamesScoresCategory* _vala_category = NULL;
	gchar** tokens = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint tokens_length1;
	gint _tokens_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint64 date = 0LL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	guint64 number_64 = 0ULL;
	guint8 cols = 0U;
	guint8 rows = 0U;
	gchar** _tmp5_;
	gint _tmp5__length1;
	const gchar* _tmp6_;
	guint64 _tmp7_ = 0ULL;
	gboolean _tmp8_;
	gboolean _tmp9_ = FALSE;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	guint64 _tmp12_ = 0ULL;
	gboolean _tmp13_;
	gboolean _tmp14_ = FALSE;
	gchar* id = NULL;
	gchar* _tmp15_;
	SwellFoopWindowSize* _tmp16_;
	gint _tmp16__length1;
	const gchar* _tmp23_;
	guint8 colors = 0U;
	glong score_value = 0L;
	gchar** _tmp24_;
	gint _tmp24__length1;
	const gchar* _tmp25_;
	guint64 _tmp26_ = 0ULL;
	gboolean _tmp27_;
	gboolean _tmp28_ = FALSE;
	gchar** _tmp29_;
	gint _tmp29__length1;
	const gchar* _tmp30_;
	guint64 _tmp31_ = 0ULL;
	gboolean _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GamesScoresCategory* _tmp39_;
	GamesScoresScore* _tmp40_;
	GamesScoresScore* _tmp41_;
	const gchar* _tmp42_;
	GamesScoresScore* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
#line 416 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 416 "../src/window.vala"
	g_return_if_fail (line != NULL);
#line 418 "../src/window.vala"
	_g_object_unref0 (_vala_score);
#line 418 "../src/window.vala"
	_vala_score = NULL;
#line 419 "../src/window.vala"
	_g_object_unref0 (_vala_category);
#line 419 "../src/window.vala"
	_vala_category = NULL;
#line 421 "../src/window.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, " ", 0);
#line 421 "../src/window.vala"
	tokens = _tmp1_;
#line 421 "../src/window.vala"
	tokens_length1 = _vala_array_length (_tmp0_);
#line 421 "../src/window.vala"
	_tokens_size_ = tokens_length1;
#line 422 "../src/window.vala"
	_tmp2_ = tokens;
#line 422 "../src/window.vala"
	_tmp2__length1 = tokens_length1;
#line 422 "../src/window.vala"
	if (_tmp2__length1 != 5) {
#line 423 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 423 "../src/window.vala"
		if (score) {
#line 423 "../src/window.vala"
			*score = _vala_score;
#line 2063 "window.c"
		} else {
#line 423 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2067 "window.c"
		}
#line 423 "../src/window.vala"
		if (category) {
#line 423 "../src/window.vala"
			*category = _vala_category;
#line 2073 "window.c"
		} else {
#line 423 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2077 "window.c"
		}
#line 423 "../src/window.vala"
		return;
#line 2081 "window.c"
	}
#line 425 "../src/window.vala"
	_tmp3_ = tokens;
#line 425 "../src/window.vala"
	_tmp3__length1 = tokens_length1;
#line 425 "../src/window.vala"
	_tmp4_ = _tmp3_[0];
#line 425 "../src/window.vala"
	date = games_scores_history_file_importer_parse_date (_tmp4_);
#line 426 "../src/window.vala"
	if (date == ((gint64) 0)) {
#line 427 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 427 "../src/window.vala"
		if (score) {
#line 427 "../src/window.vala"
			*score = _vala_score;
#line 2099 "window.c"
		} else {
#line 427 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2103 "window.c"
		}
#line 427 "../src/window.vala"
		if (category) {
#line 427 "../src/window.vala"
			*category = _vala_category;
#line 2109 "window.c"
		} else {
#line 427 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2113 "window.c"
		}
#line 427 "../src/window.vala"
		return;
#line 2117 "window.c"
	}
#line 434 "../src/window.vala"
	_tmp5_ = tokens;
#line 434 "../src/window.vala"
	_tmp5__length1 = tokens_length1;
#line 434 "../src/window.vala"
	_tmp6_ = _tmp5_[1];
#line 434 "../src/window.vala"
	_tmp8_ = uint64_try_parse (_tmp6_, &_tmp7_, NULL, (guint) 0);
#line 434 "../src/window.vala"
	number_64 = _tmp7_;
#line 434 "../src/window.vala"
	if (!_tmp8_) {
#line 435 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 435 "../src/window.vala"
		if (score) {
#line 435 "../src/window.vala"
			*score = _vala_score;
#line 2137 "window.c"
		} else {
#line 435 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2141 "window.c"
		}
#line 435 "../src/window.vala"
		if (category) {
#line 435 "../src/window.vala"
			*category = _vala_category;
#line 2147 "window.c"
		} else {
#line 435 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2151 "window.c"
		}
#line 435 "../src/window.vala"
		return;
#line 2155 "window.c"
	}
#line 436 "../src/window.vala"
	if (number_64 == ((guint64) 0)) {
#line 436 "../src/window.vala"
		_tmp9_ = TRUE;
#line 2161 "window.c"
	} else {
#line 436 "../src/window.vala"
		_tmp9_ = number_64 > ((guint64) 255);
#line 2165 "window.c"
	}
#line 436 "../src/window.vala"
	if (_tmp9_) {
#line 437 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 437 "../src/window.vala"
		if (score) {
#line 437 "../src/window.vala"
			*score = _vala_score;
#line 2175 "window.c"
		} else {
#line 437 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2179 "window.c"
		}
#line 437 "../src/window.vala"
		if (category) {
#line 437 "../src/window.vala"
			*category = _vala_category;
#line 2185 "window.c"
		} else {
#line 437 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2189 "window.c"
		}
#line 437 "../src/window.vala"
		return;
#line 2193 "window.c"
	}
#line 438 "../src/window.vala"
	cols = (guint8) number_64;
#line 440 "../src/window.vala"
	_tmp10_ = tokens;
#line 440 "../src/window.vala"
	_tmp10__length1 = tokens_length1;
#line 440 "../src/window.vala"
	_tmp11_ = _tmp10_[2];
#line 440 "../src/window.vala"
	_tmp13_ = uint64_try_parse (_tmp11_, &_tmp12_, NULL, (guint) 0);
#line 440 "../src/window.vala"
	number_64 = _tmp12_;
#line 440 "../src/window.vala"
	if (!_tmp13_) {
#line 441 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 441 "../src/window.vala"
		if (score) {
#line 441 "../src/window.vala"
			*score = _vala_score;
#line 2215 "window.c"
		} else {
#line 441 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2219 "window.c"
		}
#line 441 "../src/window.vala"
		if (category) {
#line 441 "../src/window.vala"
			*category = _vala_category;
#line 2225 "window.c"
		} else {
#line 441 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2229 "window.c"
		}
#line 441 "../src/window.vala"
		return;
#line 2233 "window.c"
	}
#line 442 "../src/window.vala"
	if (number_64 == ((guint64) 0)) {
#line 442 "../src/window.vala"
		_tmp14_ = TRUE;
#line 2239 "window.c"
	} else {
#line 442 "../src/window.vala"
		_tmp14_ = number_64 > ((guint64) 255);
#line 2243 "window.c"
	}
#line 442 "../src/window.vala"
	if (_tmp14_) {
#line 443 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 443 "../src/window.vala"
		if (score) {
#line 443 "../src/window.vala"
			*score = _vala_score;
#line 2253 "window.c"
		} else {
#line 443 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2257 "window.c"
		}
#line 443 "../src/window.vala"
		if (category) {
#line 443 "../src/window.vala"
			*category = _vala_category;
#line 2263 "window.c"
		} else {
#line 443 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2267 "window.c"
		}
#line 443 "../src/window.vala"
		return;
#line 2271 "window.c"
	}
#line 444 "../src/window.vala"
	rows = (guint8) number_64;
#line 446 "../src/window.vala"
	_tmp15_ = g_strdup ("");
#line 446 "../src/window.vala"
	id = _tmp15_;
#line 447 "../src/window.vala"
	_tmp16_ = swell_foop_window_sizes;
#line 447 "../src/window.vala"
	_tmp16__length1 = swell_foop_window_sizes_length1;
#line 2283 "window.c"
	{
		SwellFoopWindowSize* size_collection = NULL;
		gint size_collection_length1 = 0;
		gint _size_collection_size_ = 0;
		gint size_it = 0;
#line 447 "../src/window.vala"
		size_collection = _tmp16_;
#line 447 "../src/window.vala"
		size_collection_length1 = _tmp16__length1;
#line 447 "../src/window.vala"
		for (size_it = 0; size_it < size_collection_length1; size_it = size_it + 1) {
#line 2295 "window.c"
			SwellFoopWindowSize size = {0};
#line 447 "../src/window.vala"
			size = size_collection[size_it];
#line 2299 "window.c"
			{
				gboolean _tmp17_ = FALSE;
				SwellFoopWindowSize _tmp18_;
#line 449 "../src/window.vala"
				_tmp18_ = size;
#line 449 "../src/window.vala"
				if (_tmp18_.rows == rows) {
#line 2307 "window.c"
					SwellFoopWindowSize _tmp19_;
#line 449 "../src/window.vala"
					_tmp19_ = size;
#line 449 "../src/window.vala"
					_tmp17_ = _tmp19_.columns == cols;
#line 2313 "window.c"
				} else {
#line 449 "../src/window.vala"
					_tmp17_ = FALSE;
#line 2317 "window.c"
				}
#line 449 "../src/window.vala"
				if (_tmp17_) {
#line 2321 "window.c"
					SwellFoopWindowSize _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
#line 451 "../src/window.vala"
					_tmp20_ = size;
#line 451 "../src/window.vala"
					_tmp21_ = _tmp20_.id;
#line 451 "../src/window.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 451 "../src/window.vala"
					_g_free0 (id);
#line 451 "../src/window.vala"
					id = _tmp22_;
#line 452 "../src/window.vala"
					break;
#line 2337 "window.c"
				}
			}
		}
	}
#line 455 "../src/window.vala"
	_tmp23_ = id;
#line 455 "../src/window.vala"
	if (g_strcmp0 (_tmp23_, "") == 0) {
#line 456 "../src/window.vala"
		_g_free0 (id);
#line 456 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 456 "../src/window.vala"
		if (score) {
#line 456 "../src/window.vala"
			*score = _vala_score;
#line 2354 "window.c"
		} else {
#line 456 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2358 "window.c"
		}
#line 456 "../src/window.vala"
		if (category) {
#line 456 "../src/window.vala"
			*category = _vala_category;
#line 2364 "window.c"
		} else {
#line 456 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2368 "window.c"
		}
#line 456 "../src/window.vala"
		return;
#line 2372 "window.c"
	}
#line 461 "../src/window.vala"
	_tmp24_ = tokens;
#line 461 "../src/window.vala"
	_tmp24__length1 = tokens_length1;
#line 461 "../src/window.vala"
	_tmp25_ = _tmp24_[3];
#line 461 "../src/window.vala"
	_tmp27_ = uint64_try_parse (_tmp25_, &_tmp26_, NULL, (guint) 0);
#line 461 "../src/window.vala"
	number_64 = _tmp26_;
#line 461 "../src/window.vala"
	if (!_tmp27_) {
#line 462 "../src/window.vala"
		_g_free0 (id);
#line 462 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 462 "../src/window.vala"
		if (score) {
#line 462 "../src/window.vala"
			*score = _vala_score;
#line 2394 "window.c"
		} else {
#line 462 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2398 "window.c"
		}
#line 462 "../src/window.vala"
		if (category) {
#line 462 "../src/window.vala"
			*category = _vala_category;
#line 2404 "window.c"
		} else {
#line 462 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2408 "window.c"
		}
#line 462 "../src/window.vala"
		return;
#line 2412 "window.c"
	}
#line 463 "../src/window.vala"
	if (number_64 < ((guint64) 2)) {
#line 463 "../src/window.vala"
		_tmp28_ = TRUE;
#line 2418 "window.c"
	} else {
#line 463 "../src/window.vala"
		_tmp28_ = number_64 > ((guint64) 4);
#line 2422 "window.c"
	}
#line 463 "../src/window.vala"
	if (_tmp28_) {
#line 464 "../src/window.vala"
		_g_free0 (id);
#line 464 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 464 "../src/window.vala"
		if (score) {
#line 464 "../src/window.vala"
			*score = _vala_score;
#line 2434 "window.c"
		} else {
#line 464 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2438 "window.c"
		}
#line 464 "../src/window.vala"
		if (category) {
#line 464 "../src/window.vala"
			*category = _vala_category;
#line 2444 "window.c"
		} else {
#line 464 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2448 "window.c"
		}
#line 464 "../src/window.vala"
		return;
#line 2452 "window.c"
	}
#line 465 "../src/window.vala"
	colors = (guint8) number_64;
#line 467 "../src/window.vala"
	_tmp29_ = tokens;
#line 467 "../src/window.vala"
	_tmp29__length1 = tokens_length1;
#line 467 "../src/window.vala"
	_tmp30_ = _tmp29_[4];
#line 467 "../src/window.vala"
	_tmp32_ = uint64_try_parse (_tmp30_, &_tmp31_, NULL, (guint) 0);
#line 467 "../src/window.vala"
	number_64 = _tmp31_;
#line 467 "../src/window.vala"
	if (!_tmp32_) {
#line 468 "../src/window.vala"
		_g_free0 (id);
#line 468 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 468 "../src/window.vala"
		if (score) {
#line 468 "../src/window.vala"
			*score = _vala_score;
#line 2476 "window.c"
		} else {
#line 468 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2480 "window.c"
		}
#line 468 "../src/window.vala"
		if (category) {
#line 468 "../src/window.vala"
			*category = _vala_category;
#line 2486 "window.c"
		} else {
#line 468 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2490 "window.c"
		}
#line 468 "../src/window.vala"
		return;
#line 2494 "window.c"
	}
#line 469 "../src/window.vala"
	if (number_64 > ((guint64) G_MAXLONG)) {
#line 470 "../src/window.vala"
		_g_free0 (id);
#line 470 "../src/window.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 470 "../src/window.vala"
		if (score) {
#line 470 "../src/window.vala"
			*score = _vala_score;
#line 2506 "window.c"
		} else {
#line 470 "../src/window.vala"
			_g_object_unref0 (_vala_score);
#line 2510 "window.c"
		}
#line 470 "../src/window.vala"
		if (category) {
#line 470 "../src/window.vala"
			*category = _vala_category;
#line 2516 "window.c"
		} else {
#line 470 "../src/window.vala"
			_g_object_unref0 (_vala_category);
#line 2520 "window.c"
		}
#line 470 "../src/window.vala"
		return;
#line 2524 "window.c"
	}
#line 471 "../src/window.vala"
	score_value = (glong) number_64;
#line 473 "../src/window.vala"
	_tmp33_ = id;
#line 473 "../src/window.vala"
	_tmp34_ = string_to_string (_tmp33_);
#line 473 "../src/window.vala"
	_tmp35_ = g_strdup_printf ("%hhu", colors);
#line 473 "../src/window.vala"
	_tmp36_ = _tmp35_;
#line 473 "../src/window.vala"
	_tmp37_ = g_strconcat (_tmp34_, "-", _tmp36_, NULL);
#line 473 "../src/window.vala"
	_tmp38_ = _tmp37_;
#line 473 "../src/window.vala"
	_tmp39_ = swell_foop_window_category_request (self, _tmp38_);
#line 473 "../src/window.vala"
	_g_object_unref0 (_vala_category);
#line 473 "../src/window.vala"
	_vala_category = _tmp39_;
#line 473 "../src/window.vala"
	_g_free0 (_tmp38_);
#line 473 "../src/window.vala"
	_g_free0 (_tmp36_);
#line 474 "../src/window.vala"
	_tmp40_ = games_scores_score_new (score_value, date, NULL);
#line 474 "../src/window.vala"
	_g_object_unref0 (_vala_score);
#line 474 "../src/window.vala"
	_vala_score = _tmp40_;
#line 475 "../src/window.vala"
	_tmp41_ = _vala_score;
#line 475 "../src/window.vala"
	_tmp42_ = g_get_real_name ();
#line 475 "../src/window.vala"
	games_scores_score_set_user (_tmp41_, _tmp42_);
#line 476 "../src/window.vala"
	_tmp43_ = _vala_score;
#line 476 "../src/window.vala"
	_tmp44_ = games_scores_score_get_user (_tmp43_);
#line 476 "../src/window.vala"
	_tmp45_ = _tmp44_;
#line 476 "../src/window.vala"
	if (g_strcmp0 (_tmp45_, "Unknown") == 0) {
#line 2570 "window.c"
		GamesScoresScore* _tmp46_;
		const gchar* _tmp47_;
#line 477 "../src/window.vala"
		_tmp46_ = _vala_score;
#line 477 "../src/window.vala"
		_tmp47_ = g_get_user_name ();
#line 477 "../src/window.vala"
		games_scores_score_set_user (_tmp46_, _tmp47_);
#line 2579 "window.c"
	}
#line 416 "../src/window.vala"
	_g_free0 (id);
#line 416 "../src/window.vala"
	tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 416 "../src/window.vala"
	if (score) {
#line 416 "../src/window.vala"
		*score = _vala_score;
#line 2589 "window.c"
	} else {
#line 416 "../src/window.vala"
		_g_object_unref0 (_vala_score);
#line 2593 "window.c"
	}
#line 416 "../src/window.vala"
	if (category) {
#line 416 "../src/window.vala"
		*category = _vala_category;
#line 2599 "window.c"
	} else {
#line 416 "../src/window.vala"
		_g_object_unref0 (_vala_category);
#line 2603 "window.c"
	}
}

static void
__lambda8_ (SwellFoopWindow* self,
            GObject* object,
            GAsyncResult* _result_)
{
	GamesScoresContext* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 489 "../src/window.vala"
	g_return_if_fail (_result_ != NULL);
#line 2616 "window.c"
	{
		GamesScoresContext* _tmp0_;
#line 492 "../src/window.vala"
		_tmp0_ = self->priv->scores_context;
#line 492 "../src/window.vala"
		games_scores_context_add_score_finish (_tmp0_, _result_, &_inner_error0_);
#line 492 "../src/window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2625 "window.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 490 "../src/window.vala"
		e = _inner_error0_;
#line 490 "../src/window.vala"
		_inner_error0_ = NULL;
#line 496 "../src/window.vala"
		_tmp1_ = e;
#line 496 "../src/window.vala"
		_tmp2_ = _tmp1_->message;
#line 496 "../src/window.vala"
		g_warning ("window.vala:496: Failed to add score: %s", _tmp2_);
#line 490 "../src/window.vala"
		_g_error_free0 (e);
#line 2647 "window.c"
	}
	__finally0:
#line 490 "../src/window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 490 "../src/window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 490 "../src/window.vala"
		g_clear_error (&_inner_error0_);
#line 490 "../src/window.vala"
		return;
#line 2658 "window.c"
	}
#line 498 "../src/window.vala"
	_tmp3_ = self->priv->scores_context;
#line 498 "../src/window.vala"
	games_scores_context_run_dialog (_tmp3_);
#line 2664 "window.c"
}

static void
___lambda8__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 486 "../src/window.vala"
	__lambda8_ ((SwellFoopWindow*) self, source_object, res);
#line 486 "../src/window.vala"
	g_object_unref (self);
#line 2676 "window.c"
}

static inline void
swell_foop_window_add_score (SwellFoopWindow* self)
{
	gchar* id = NULL;
	SwellFoopWindowSize _tmp0_ = {0};
	SwellFoopWindowSize _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	Game* _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GamesScoresCategory* category = NULL;
	GHashTable* _tmp11_;
	gconstpointer _tmp12_;
	GamesScoresCategory* _tmp13_;
	GamesScoresContext* _tmp14_;
	Game* _tmp15_;
	guint _tmp16_;
	guint _tmp17_;
#line 480 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/window.vala"
	swell_foop_window_get_board_size (self, &_tmp0_);
#line 482 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 482 "../src/window.vala"
	_tmp2_ = _tmp1_.id;
#line 482 "../src/window.vala"
	_tmp3_ = string_to_string (_tmp2_);
#line 482 "../src/window.vala"
	_tmp4_ = self->priv->game;
#line 482 "../src/window.vala"
	_tmp5_ = game_get_color_num (_tmp4_);
#line 482 "../src/window.vala"
	_tmp6_ = _tmp5_;
#line 482 "../src/window.vala"
	_tmp7_ = g_strdup_printf ("%hhu", _tmp6_);
#line 482 "../src/window.vala"
	_tmp8_ = _tmp7_;
#line 482 "../src/window.vala"
	_tmp9_ = g_strconcat (_tmp3_, "-", _tmp8_, NULL);
#line 482 "../src/window.vala"
	_tmp10_ = _tmp9_;
#line 482 "../src/window.vala"
	_g_free0 (_tmp8_);
#line 482 "../src/window.vala"
	swell_foop_window_size_destroy (&_tmp1_);
#line 482 "../src/window.vala"
	id = _tmp10_;
#line 483 "../src/window.vala"
	_tmp11_ = swell_foop_window_score_categories;
#line 483 "../src/window.vala"
	_tmp12_ = g_hash_table_lookup (_tmp11_, id);
#line 483 "../src/window.vala"
	_tmp13_ = _g_object_ref0 ((GamesScoresCategory*) _tmp12_);
#line 483 "../src/window.vala"
	category = _tmp13_;
#line 484 "../src/window.vala"
	if (category == NULL) {
#line 485 "../src/window.vala"
		g_assert_not_reached ();
#line 2744 "window.c"
	}
#line 486 "../src/window.vala"
	_tmp14_ = self->priv->scores_context;
#line 486 "../src/window.vala"
	_tmp15_ = self->priv->game;
#line 486 "../src/window.vala"
	_tmp16_ = game_get_score (_tmp15_);
#line 486 "../src/window.vala"
	_tmp17_ = _tmp16_;
#line 486 "../src/window.vala"
	games_scores_context_add_score (_tmp14_, (glong) _tmp17_, G_TYPE_CHECK_INSTANCE_CAST (category, GAMES_SCORES_TYPE_CATEGORY, GamesScoresCategory), NULL, ___lambda8__gasync_ready_callback, g_object_ref (self));
#line 480 "../src/window.vala"
	_g_object_unref0 (category);
#line 480 "../src/window.vala"
	_g_free0 (id);
#line 2760 "window.c"
}

static void
_game_view_board_left_cb_gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                            gpointer self)
{
#line 512 "../src/window.vala"
	game_view_board_left_cb ((GameView*) self);
#line 2769 "window.c"
}

static inline void
swell_foop_window_init_motion (SwellFoopWindow* self)
{
	GameView* _tmp0_;
	GtkEventControllerMotion* _tmp1_;
	GtkEventControllerMotion* _tmp2_;
	GtkEventControllerMotion* _tmp3_;
	GameView* _tmp4_;
#line 508 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 510 "../src/window.vala"
	_tmp0_ = self->priv->view;
#line 510 "../src/window.vala"
	_tmp1_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ((GtkWidget*) _tmp0_);
#line 510 "../src/window.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 510 "../src/window.vala"
	self->priv->motion_controller = _tmp1_;
#line 511 "../src/window.vala"
	_tmp2_ = self->priv->motion_controller;
#line 511 "../src/window.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp2_, GTK_PHASE_CAPTURE);
#line 512 "../src/window.vala"
	_tmp3_ = self->priv->motion_controller;
#line 512 "../src/window.vala"
	_tmp4_ = self->priv->view;
#line 512 "../src/window.vala"
	g_signal_connect_object (_tmp3_, "leave", (GCallback) _game_view_board_left_cb_gtk_event_controller_motion_leave, _tmp4_, 0);
#line 2800 "window.c"
}

static void
swell_foop_window_size_copy (const SwellFoopWindowSize* self,
                             SwellFoopWindowSize* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 40 "../src/window.vala"
	_tmp0_ = (*self).id;
#line 40 "../src/window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 40 "../src/window.vala"
	_g_free0 ((*dest).id);
#line 40 "../src/window.vala"
	(*dest).id = _tmp1_;
#line 40 "../src/window.vala"
	_tmp2_ = (*self).name;
#line 40 "../src/window.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 40 "../src/window.vala"
	_g_free0 ((*dest).name);
#line 40 "../src/window.vala"
	(*dest).name = _tmp3_;
#line 40 "../src/window.vala"
	(*dest).columns = (*self).columns;
#line 40 "../src/window.vala"
	(*dest).rows = (*self).rows;
#line 2831 "window.c"
}

static void
swell_foop_window_size_destroy (SwellFoopWindowSize* self)
{
#line 42 "../src/window.vala"
	_g_free0 ((*self).id);
#line 43 "../src/window.vala"
	_g_free0 ((*self).name);
#line 2841 "window.c"
}

static SwellFoopWindowSize*
swell_foop_window_size_dup (const SwellFoopWindowSize* self)
{
	SwellFoopWindowSize* dup;
#line 40 "../src/window.vala"
	dup = g_new0 (SwellFoopWindowSize, 1);
#line 40 "../src/window.vala"
	swell_foop_window_size_copy (self, dup);
#line 40 "../src/window.vala"
	return dup;
#line 2854 "window.c"
}

static void
swell_foop_window_size_free (SwellFoopWindowSize* self)
{
#line 40 "../src/window.vala"
	swell_foop_window_size_destroy (self);
#line 40 "../src/window.vala"
	g_free (self);
#line 2864 "window.c"
}

static GType
swell_foop_window_size_get_type_once (void)
{
	GType swell_foop_window_size_type_id;
	swell_foop_window_size_type_id = g_boxed_type_register_static ("SwellFoopWindowSize", (GBoxedCopyFunc) swell_foop_window_size_dup, (GBoxedFreeFunc) swell_foop_window_size_free);
	return swell_foop_window_size_type_id;
}

static GType
swell_foop_window_size_get_type (void)
{
	static volatile gsize swell_foop_window_size_type_id__once = 0;
	if (g_once_init_enter (&swell_foop_window_size_type_id__once)) {
		GType swell_foop_window_size_type_id;
		swell_foop_window_size_type_id = swell_foop_window_size_get_type_once ();
		g_once_init_leave (&swell_foop_window_size_type_id__once, swell_foop_window_size_type_id);
	}
	return swell_foop_window_size_type_id__once;
}

static void
_swell_foop_window___lambda10_ (SwellFoopWindow* self,
                                GSettings* _settings,
                                const gchar* _key_name)
{
	GameView* _tmp0_;
#line 88 "../src/window.vala"
	g_return_if_fail (_settings != NULL);
#line 88 "../src/window.vala"
	g_return_if_fail (_key_name != NULL);
#line 88 "../src/window.vala"
	_tmp0_ = self->priv->view;
#line 88 "../src/window.vala"
	game_view_set_is_zealous (_tmp0_, g_settings_get_boolean (_settings, _key_name));
#line 2901 "window.c"
}

static void
__swell_foop_window___lambda10__g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self)
{
#line 88 "../src/window.vala"
	_swell_foop_window___lambda10_ ((SwellFoopWindow*) self, _sender, key);
#line 2911 "window.c"
}

static GObject *
swell_foop_window_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SwellFoopWindow * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GAction* _tmp2_;
	GAction* _tmp3_;
	GSettings* _tmp4_;
	GAction* _tmp5_;
	GAction* _tmp6_;
	GSettings* _tmp7_;
	gchar* theme = NULL;
	GSettings* _tmp8_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	GSimpleAction* theme_action = NULL;
	GAction* _tmp16_;
	GSimpleAction* _tmp17_;
	GSimpleAction* _tmp18_;
	const gchar* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	gint32 colors = 0;
	GSettings* _tmp22_;
	GSimpleAction* colors_action = NULL;
	GAction* _tmp23_;
	GSimpleAction* _tmp24_;
	GSimpleAction* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GVariant* _tmp28_;
	GVariant* _tmp29_;
	GameView* _tmp30_;
	GameView* _tmp31_;
	gboolean first_run = FALSE;
	GSettings* _tmp32_;
#line 80 "../src/window.vala"
	parent_class = G_OBJECT_CLASS (swell_foop_window_parent_class);
#line 80 "../src/window.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 80 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SWELL_FOOP_WINDOW, SwellFoopWindow);
#line 82 "../src/window.vala"
	_tmp0_ = g_settings_new ("org.gnome.SwellFoop");
#line 82 "../src/window.vala"
	_g_object_unref0 (self->priv->settings);
#line 82 "../src/window.vala"
	self->priv->settings = _tmp0_;
#line 84 "../src/window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, SWELL_FOOP_WINDOW_win_actions, (gint) G_N_ELEMENTS (SWELL_FOOP_WINDOW_win_actions), self);
#line 85 "../src/window.vala"
	_tmp1_ = self->priv->settings;
#line 85 "../src/window.vala"
	_tmp2_ = g_settings_create_action (_tmp1_, "size");
#line 85 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 85 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp3_);
#line 85 "../src/window.vala"
	_g_object_unref0 (_tmp3_);
#line 87 "../src/window.vala"
	_tmp4_ = self->priv->settings;
#line 87 "../src/window.vala"
	_tmp5_ = g_settings_create_action (_tmp4_, "zealous");
#line 87 "../src/window.vala"
	_tmp6_ = _tmp5_;
#line 87 "../src/window.vala"
	g_action_map_add_action ((GActionMap*) self, _tmp6_);
#line 87 "../src/window.vala"
	_g_object_unref0 (_tmp6_);
#line 88 "../src/window.vala"
	_tmp7_ = self->priv->settings;
#line 88 "../src/window.vala"
	g_signal_connect_object (_tmp7_, "changed::zealous", (GCallback) __swell_foop_window___lambda10__g_settings_changed, self, 0);
#line 90 "../src/window.vala"
	_tmp8_ = self->priv->settings;
#line 90 "../src/window.vala"
	_tmp9_ = g_settings_get_string (_tmp8_, "theme");
#line 90 "../src/window.vala"
	theme = _tmp9_;
#line 91 "../src/window.vala"
	_tmp12_ = theme;
#line 91 "../src/window.vala"
	if (g_strcmp0 (_tmp12_, "colors") != 0) {
#line 3005 "window.c"
		const gchar* _tmp13_;
#line 91 "../src/window.vala"
		_tmp13_ = theme;
#line 91 "../src/window.vala"
		_tmp11_ = g_strcmp0 (_tmp13_, "shapesandcolors") != 0;
#line 3011 "window.c"
	} else {
#line 91 "../src/window.vala"
		_tmp11_ = FALSE;
#line 3015 "window.c"
	}
#line 91 "../src/window.vala"
	if (_tmp11_) {
#line 3019 "window.c"
		const gchar* _tmp14_;
#line 91 "../src/window.vala"
		_tmp14_ = theme;
#line 91 "../src/window.vala"
		_tmp10_ = g_strcmp0 (_tmp14_, "boringshapes") != 0;
#line 3025 "window.c"
	} else {
#line 91 "../src/window.vala"
		_tmp10_ = FALSE;
#line 3029 "window.c"
	}
#line 91 "../src/window.vala"
	if (_tmp10_) {
#line 3033 "window.c"
		gchar* _tmp15_;
#line 92 "../src/window.vala"
		_tmp15_ = g_strdup ("shapesandcolors");
#line 92 "../src/window.vala"
		_g_free0 (theme);
#line 92 "../src/window.vala"
		theme = _tmp15_;
#line 3041 "window.c"
	}
#line 93 "../src/window.vala"
	_tmp16_ = g_action_map_lookup_action ((GActionMap*) self, "change-theme");
#line 93 "../src/window.vala"
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, g_simple_action_get_type (), GSimpleAction));
#line 93 "../src/window.vala"
	theme_action = _tmp17_;
#line 94 "../src/window.vala"
	_tmp18_ = theme_action;
#line 94 "../src/window.vala"
	_tmp19_ = theme;
#line 94 "../src/window.vala"
	_tmp20_ = g_variant_new_string (_tmp19_);
#line 94 "../src/window.vala"
	g_variant_ref_sink (_tmp20_);
#line 94 "../src/window.vala"
	_tmp21_ = _tmp20_;
#line 94 "../src/window.vala"
	g_simple_action_set_state (_tmp18_, _tmp21_);
#line 94 "../src/window.vala"
	_g_variant_unref0 (_tmp21_);
#line 96 "../src/window.vala"
	_tmp22_ = self->priv->settings;
#line 96 "../src/window.vala"
	colors = (gint32) g_settings_get_int (_tmp22_, "colors");
#line 97 "../src/window.vala"
	_tmp23_ = g_action_map_lookup_action ((GActionMap*) self, "change-colors");
#line 97 "../src/window.vala"
	_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, g_simple_action_get_type (), GSimpleAction));
#line 97 "../src/window.vala"
	colors_action = _tmp24_;
#line 98 "../src/window.vala"
	_tmp25_ = colors_action;
#line 98 "../src/window.vala"
	_tmp26_ = g_strdup_printf ("%i", colors);
#line 98 "../src/window.vala"
	_tmp27_ = _tmp26_;
#line 98 "../src/window.vala"
	_tmp28_ = g_variant_new_string (_tmp27_);
#line 98 "../src/window.vala"
	g_variant_ref_sink (_tmp28_);
#line 98 "../src/window.vala"
	_tmp29_ = _tmp28_;
#line 98 "../src/window.vala"
	g_simple_action_set_state (_tmp25_, _tmp29_);
#line 98 "../src/window.vala"
	_g_variant_unref0 (_tmp29_);
#line 98 "../src/window.vala"
	_g_free0 (_tmp27_);
#line 100 "../src/window.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK));
#line 102 "../src/window.vala"
	swell_foop_window_init_scores (self);
#line 105 "../src/window.vala"
	swell_foop_window_update_score_cb (self);
#line 108 "../src/window.vala"
	_tmp30_ = game_view_new ();
#line 108 "../src/window.vala"
	g_object_ref_sink (_tmp30_);
#line 108 "../src/window.vala"
	_g_object_unref0 (self->priv->view);
#line 108 "../src/window.vala"
	self->priv->view = _tmp30_;
#line 109 "../src/window.vala"
	_tmp31_ = self->priv->view;
#line 109 "../src/window.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 110 "../src/window.vala"
	_tmp32_ = self->priv->settings;
#line 110 "../src/window.vala"
	first_run = g_settings_get_boolean (_tmp32_, "first-run");
#line 112 "../src/window.vala"
	if (first_run) {
#line 3115 "window.c"
		GtkStack* stack = NULL;
		GtkStack* _tmp33_;
		GtkStack* _tmp34_;
		GameView* _tmp35_;
		GtkBox* _tmp36_;
		GtkStack* _tmp37_;
#line 114 "../src/window.vala"
		_tmp33_ = swell_foop_window_build_first_run_stack (self);
#line 114 "../src/window.vala"
		stack = _tmp33_;
#line 115 "../src/window.vala"
		_tmp34_ = stack;
#line 115 "../src/window.vala"
		_tmp35_ = self->priv->view;
#line 115 "../src/window.vala"
		gtk_stack_add_named (_tmp34_, (GtkWidget*) _tmp35_, "game");
#line 116 "../src/window.vala"
		_tmp36_ = self->priv->main_box;
#line 116 "../src/window.vala"
		_tmp37_ = stack;
#line 116 "../src/window.vala"
		gtk_box_pack_start (_tmp36_, (GtkWidget*) _tmp37_, TRUE, TRUE, (guint) 0);
#line 112 "../src/window.vala"
		_g_object_unref0 (stack);
#line 3140 "window.c"
	} else {
		GtkBox* _tmp38_;
		GameView* _tmp39_;
#line 120 "../src/window.vala"
		_tmp38_ = self->priv->main_box;
#line 120 "../src/window.vala"
		_tmp39_ = self->priv->view;
#line 120 "../src/window.vala"
		gtk_box_pack_start (_tmp38_, (GtkWidget*) _tmp39_, TRUE, TRUE, (guint) 0);
#line 121 "../src/window.vala"
		swell_foop_window_init_keyboard (self);
#line 3152 "window.c"
	}
#line 80 "../src/window.vala"
	_g_object_unref0 (colors_action);
#line 80 "../src/window.vala"
	_g_object_unref0 (theme_action);
#line 80 "../src/window.vala"
	_g_free0 (theme);
#line 80 "../src/window.vala"
	return obj;
#line 3162 "window.c"
}

static void
swell_foop_window_base_init (SwellFoopWindowClass * klass)
{
#line 64 "../src/window.vala"
	swell_foop_window_class_init_sizes ();
#line 65 "../src/window.vala"
	swell_foop_window_class_init_scores ();
#line 3172 "window.c"
}

static void
swell_foop_window_class_init (SwellFoopWindowClass * klass,
                              gpointer klass_data)
{
#line 23 "../src/window.vala"
	swell_foop_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &SwellFoopWindow_private_offset);
#line 23 "../src/window.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) swell_foop_window_real_destroy;
#line 23 "../src/window.vala"
	G_OBJECT_CLASS (klass)->constructor = swell_foop_window_constructor;
#line 23 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = swell_foop_window_finalize;
#line 23 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SwellFoop/ui/swell-foop.ui");
#line 23 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, SwellFoopWindow_private_offset + G_STRUCT_OFFSET (SwellFoopWindowPrivate, headerbar));
#line 23 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_box", FALSE, SwellFoopWindow_private_offset + G_STRUCT_OFFSET (SwellFoopWindowPrivate, main_box));
#line 23 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hamburger_button", FALSE, SwellFoopWindow_private_offset + G_STRUCT_OFFSET (SwellFoopWindowPrivate, hamburger_button));
#line 3197 "window.c"
}

static void
swell_foop_window_instance_init (SwellFoopWindow * self,
                                 gpointer klass)
{
#line 23 "../src/window.vala"
	self->priv = swell_foop_window_get_instance_private (self);
#line 32 "../src/window.vala"
	self->priv->game = NULL;
#line 37 "../src/window.vala"
	self->priv->game_in_progress = FALSE;
#line 23 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 3212 "window.c"
}

static void
swell_foop_window_finalize (GObject * obj)
{
	SwellFoopWindow * self;
#line 23 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SWELL_FOOP_WINDOW, SwellFoopWindow);
#line 29 "../src/window.vala"
	_g_object_unref0 (self->priv->settings);
#line 32 "../src/window.vala"
	_g_object_unref0 (self->priv->game);
#line 35 "../src/window.vala"
	_g_object_unref0 (self->priv->view);
#line 206 "../src/window.vala"
	_g_object_unref0 (self->priv->undo_action);
#line 207 "../src/window.vala"
	_g_object_unref0 (self->priv->redo_action);
#line 331 "../src/window.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 379 "../src/window.vala"
	_g_object_unref0 (self->priv->scores_context);
#line 506 "../src/window.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 23 "../src/window.vala"
	G_OBJECT_CLASS (swell_foop_window_parent_class)->finalize (obj);
#line 3239 "window.c"
}

static GType
swell_foop_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SwellFoopWindowClass), (GBaseInitFunc) swell_foop_window_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) swell_foop_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwellFoopWindow), 0, (GInstanceInitFunc) swell_foop_window_instance_init, NULL };
	GType swell_foop_window_type_id;
	swell_foop_window_type_id = g_type_register_static (gtk_application_window_get_type (), "SwellFoopWindow", &g_define_type_info, 0);
	SwellFoopWindow_private_offset = g_type_add_instance_private (swell_foop_window_type_id, sizeof (SwellFoopWindowPrivate));
	return swell_foop_window_type_id;
}

GType
swell_foop_window_get_type (void)
{
	static volatile gsize swell_foop_window_type_id__once = 0;
	if (g_once_init_enter (&swell_foop_window_type_id__once)) {
		GType swell_foop_window_type_id;
		swell_foop_window_type_id = swell_foop_window_get_type_once ();
		g_once_init_leave (&swell_foop_window_type_id__once, swell_foop_window_type_id);
	}
	return swell_foop_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

